import { RunOptions } from './types';
export declare class Config {
    /**
     * Local settings
     */
    debug: boolean;
    windows: boolean;
    bin: string;
    mock: boolean;
    argv: string[];
    commandsDir: string;
    defaultCommand: string;
    userPlugins: boolean;
    version: string;
    name: string;
    pjson: any;
    /**
     * Paths
     */
    root: string;
    envPath: string;
    definitionDir: string;
    home: string;
    dotGraphcoolFilePath: string;
    /**
     * Urls
     */
    token: string | null;
    authUIEndpoint: string;
    backendAddr: string;
    systemAPIEndpoint: string;
    authEndpoint: string;
    docsEndpoint: string;
    statusEndpoint: string;
    __cache: {};
    constructor(options?: RunOptions);
    setToken(token: string | null): void;
    saveToken(): void;
    readonly arch: string;
    readonly platform: string;
    readonly userAgent: string;
    readonly dirname: any;
    readonly cacheDir: string;
}
