"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
require("source-map-support/register");
var screen_1 = require("../Output/actions/screen");
var util_1 = require("../util");
var Command_1 = require("../Command");
var Plugins_1 = require("../Plugin/Plugins");
function trimToMaxLeft(n) {
    var max = Math.floor(screen_1.stdtermwidth * 0.6);
    return n > max ? max : n;
}
function trimCmd(s, max) {
    if (s.length <= max) {
        return s;
    }
    return s.slice(0, max - 1) + "\u2026";
}
function renderList(items) {
    var S = require('string');
    var max = require('lodash.maxby');
    var maxLeftLength = trimToMaxLeft(max(items, '[0].length')[0].length + 1);
    return items
        .map(function (i) {
        var left = " " + i[0];
        var right = i[1];
        if (!right) {
            return left;
        }
        left = "" + S(trimCmd(left, maxLeftLength)).padRight(maxLeftLength);
        right = util_1.linewrap(maxLeftLength + 2, right);
        return left + "    " + right;
    }).join('\n');
}
var Help = (function (_super) {
    __extends(Help, _super);
    function Help() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Help.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, topic, matchedCommand, cmds, subtopics;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.plugins = new Plugins_1.default(this.out);
                        return [4 /*yield*/, this.plugins.load()];
                    case 1:
                        _a.sent();
                        cmd = this.config.argv.slice(1).find(function (arg) { return !['help', '-h', '--help'].includes(arg); });
                        if (!cmd) {
                            return [2 /*return*/, this.topics()];
                        }
                        return [4 /*yield*/, this.plugins.findTopic(cmd)];
                    case 2:
                        topic = _a.sent();
                        return [4 /*yield*/, this.plugins.findCommand(cmd)];
                    case 3:
                        matchedCommand = _a.sent();
                        if (!topic && !matchedCommand) {
                            throw new Error("command " + cmd + " not found");
                        }
                        if (matchedCommand) {
                            this.out.log(matchedCommand.buildHelp(this.config));
                        }
                        if (!topic) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.plugins.commandsForTopic(topic.id)];
                    case 4:
                        cmds = _a.sent();
                        return [4 /*yield*/, this.plugins.subtopicsForTopic(topic.id)];
                    case 5:
                        subtopics = _a.sent();
                        if (subtopics && subtopics.length) {
                            this.topics(subtopics, topic.id, (topic.id.split(':').length + 1));
                        }
                        if (cmds) {
                            this.listCommandsHelp(cmd, cmds);
                        }
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    Help.prototype.topics = function (ptopics, id, offset) {
        var _this = this;
        if (ptopics === void 0) { ptopics = null; }
        if (id === void 0) { id = null; }
        if (offset === void 0) { offset = 1; }
        var color = this.out.color;
        this.out.log(color.bold('Usage:') + " " + this.config.bin + " " + (id || '') + (id ? ' ' : '') + "COMMAND\n\nHelp topics, type " + this.out.color.cmd(this.config.bin + ' help TOPIC') + " for more details:\n");
        var topics = (ptopics || this.plugins.topics).filter(function (t) {
            if (!t.id) {
                return;
            }
            var subtopic = t.id.split(':')[offset];
            return !t.hidden && !subtopic;
        });
        topics = topics.map(function (t) { return ([
            t.id,
            t.description ? _this.out.color.dim(t.description) : null
        ]); });
        topics.sort();
        this.out.log(renderList(topics));
        this.out.log('');
    };
    Help.prototype.listCommandsHelp = function (topic, commands) {
        var _this = this;
        commands = commands.filter(function (c) { return !c.hidden; });
        if (commands.length <= 1) {
            return;
        }
        commands.sort(util_1.compare('command'));
        var helpCmd = this.out.color.cmd(this.config.bin + " help " + topic + " COMMAND");
        this.out.log(this.config.bin + " " + this.out.color.bold(topic) + " commands: (get help with " + helpCmd + ")");
        this.out.log(renderList(commands.map(function (c) { return c.buildHelpLine(_this.config); })));
        this.out.log('');
    };
    Help.topic = 'help';
    Help.description = 'display help';
    Help.variableArgs = true;
    return Help;
}(Command_1.Command));
exports.default = Help;
//# sourceMappingURL=help.js.map