declare const _default: {
    "$schema": string;
    "title": string;
    "definitions": {
        "function": {
            "description": string;
            "type": string;
            "properties": {
                "isEnabled": {
                    "type": string;
                    "default": boolean;
                };
                "handler": {
                    "oneOf": ({
                        "type": string;
                        "additionalProperties": boolean;
                        "minProperties": number;
                        "properties": {
                            "code": {
                                "oneOf": {
                                    "type": string;
                                    "properties": {
                                        "src": {
                                            "type": string;
                                        };
                                    };
                                    "required": string[];
                                }[];
                            };
                        };
                    } | {
                        "type": string;
                        "additionalProperties": boolean;
                        "minProperties": number;
                        "properties": {
                            "webhook": {
                                "oneOf": ({
                                    "type": string;
                                } | {
                                    "type": string;
                                    "properties": {
                                        "url": {
                                            "type": string;
                                        };
                                        "headers": {
                                            "type": string;
                                        };
                                    };
                                    "required": string[];
                                })[];
                            };
                        };
                    })[];
                };
                "type": {
                    "enum": string[];
                };
                "operation": {
                    "type": string;
                    "pattern": string;
                };
                "schema": {
                    "type": string;
                };
                "query": {
                    "type": string;
                };
            };
            "required": string[];
        };
        "permission": {
            "description": string;
            "type": string;
            "properties": {
                "operation": {
                    "type": string;
                    "pattern": string;
                };
                "authenticated": {
                    "type": string;
                    "default": boolean;
                };
                "isEnabled": {
                    "type": string;
                    "default": boolean;
                };
                "query": {
                    "type": string;
                };
                "fields": {
                    "type": string;
                    "items": {
                        "type": string;
                    };
                };
            };
            "required": string[];
        };
    };
    "properties": {
        "types": {
            "description": string;
            "type": string[];
            "items": {
                "type": string;
            };
        };
        "rootTokens": {
            "description": string;
            "type": string;
            "items": {
                "type": string;
            };
        };
        "functions": {
            "description": string;
            "type": string;
            "additionalProperties": {
                "$ref": string;
            };
        };
        "permissions": {
            "description": string;
            "type": string;
            "items": {
                "$ref": string;
            };
        };
        "modules": {
            "description": string;
            "type": string;
        };
    };
    "additionalProperties": boolean;
    "required": string[];
};
export default _default;
